/*
 * Created at regulus on 15-sep-2004 23:24:32
 * as file SumOfIntegersExpression.java on package element
 */
package element;

import java.util.ArrayList;
import java.util.StringTokenizer;
import java.util.regex.Pattern;

import element.IntElement;

/**
 * @author carlos
 *
 * Created at regulus, 15-sep-2004 23:24:32
 */
public class SumOfIntegersExpression extends ExpressionElement 
{

	/**
	 * @param children Sumandos de esta suma de enteros.
	 */
	public SumOfIntegersExpression(Element[] children) 
	{
		super(children);
	}

    /**
     * La expresin suma de enteros devuelve como cdigo Java el entero
     * cuyo valor es la suma de los valores de los miembros.
     */
	public String getExpressionCode(String[] memberNames) 
	{
        StringBuffer result = new StringBuffer("");
        result.append("IntElement.groundIntElement(");
        //result.append("new IntElement(");
        for ( int i = 0 ; i < memberNames.length ; i++ )
        {
           	result.append("+");
           	result.append("(");
           	result.append(memberNames[i]);
           	result.append(".getValue()");
           	result.append(")");
        }
        //result.append(",true)");
        result.append(")");
        return result.toString();
	}
	
    public boolean isGround ()
    {
        return false;
    }
    
    /**
     * La clase resultante de una expresin de tipo suma de enteros es la clase
     * de elementos enteros.
     */
    public Class getResultingClass()
    {
    	return IntElement.class;
    }

    /**
     * Obtiene una expresin suma de enteros a partir de la cadena que
     * la representa.
     * @param sparm Cadena representando una expresin suma de enteros.
     * @return Elemento correspondiente de tipo SumOfIntegersExpression.
     */
    public static SumOfIntegersExpression fromString ( String sparm )
    {
    	//remove #'s
    	//StringTokenizer st1 = new StringTokenizer(sparm,"#",false);
    	//String s = "";
    	//while ( st1.hasMoreTokens() ) s += st1.nextToken();
    	
    	String s = sparm;
    	StringTokenizer st = new StringTokenizer ( s , "+-" , true );
        ArrayList children = new ArrayList();
        boolean positive = true; //signo
        while ( st.hasMoreTokens() )
        {
            String tok = st.nextToken().trim();                     
            if ( tok.equals("+") ) ;
            if ( tok.equals("-") ) positive = !positive;
            if ( Pattern.compile("#[0-9]+").matcher(tok).matches() )
            {
            	System.out.println("Tok:" + tok);
            	if ( tok.startsWith("#") )
            		tok = tok.substring(1);
                String intEltTok = tok;
                if ( !positive )
                    intEltTok = "-" + tok;
                System.out.println("Add: " + new IntElement(Integer.valueOf(intEltTok).intValue(),true ) );
                children.add( new IntElement(Integer.valueOf(intEltTok).intValue(),true) );
                positive = true;
            }
            if ( Pattern.compile("#[i-kp]+").matcher(tok).matches()
            	|| Pattern.compile("#e[0-9]+").matcher(tok).matches()	
            	|| Pattern.compile("#e").matcher(tok).matches()
            )
            {
                children.add( IntElement.nonGroundIntElement(tok) );
                positive = true;
            }     
        }
        System.out.println("Expr was: " + sparm + " nelts: " + children.size());
        return new SumOfIntegersExpression( (Element[])children.toArray(new Element[0]) );
    }
    
    class SumOfIntegersFormatException extends Exception
    {
        public SumOfIntegersFormatException()
        {
            super();
        }
    }

}
