package grammar.tag.util;

import org.w3c.dom.Element;

import util.DOMNodeWrapper;

public class AnchorDoubler extends AbstractGrammarTransformer
{

	
	public AnchorDoubler(String inFile, String outFile, AbstractGrammarTransformer next) 
	{
		super(inFile, outFile, next);
	}

	public AnchorDoubler(String inFile, String outFile) 
	{
		super(inFile, outFile);
	}

	public AnchorDoubler(AbstractGrammarTransformer next) 
	{
		super(next);
	}
	
	public String toString()
	{
		return "Doubling anchor nodes";
	}
	
	public void postprocessNodeNode(DOMNodeWrapper nodeNode)
	{
		String type = nodeNode.getAttribute("type");
		if ( type.equalsIgnoreCase("anchor") )
		{
			Element e = (Element) nodeNode.getNode();
			Element newChild = (Element) e.cloneNode(true); //deep cloning
			e.setAttribute("type","adj"); //upper anchor allows adjunction
			e.appendChild(newChild); //establish parent-child relationship
		}
	}

}
