package grammar.tag.util;

import org.w3c.dom.Element;

import util.DOMNodeWrapper;

public class EpsilonRenamer extends AbstractGrammarTransformer
{

	private String name;
	
	public String toString()
	{
		return "Renaming Epsilon nodes to " + name;
	}
	
	public EpsilonRenamer(String name, String inFile, String outFile, AbstractGrammarTransformer next) 
	{
		super(inFile, outFile, next);
		this.name=name;
	}

	public EpsilonRenamer(String name, String inFile, String outFile) 
	{
		super(inFile, outFile);
		this.name=name;
	}

	public EpsilonRenamer(String name, AbstractGrammarTransformer next) 
	{
		super(next);
		this.name=name;
	}
	
	public void preprocessNodeNode(DOMNodeWrapper nodeNode)
	{
		String cat = nodeNode.getAttribute("cat");
		if ( cat!=null && cat.length() == 0 )
		{
			Element e = (Element) nodeNode.getNode();
			e.setAttribute("cat",name);
		}
	}

}
