package schema.item;

/**
 * Esta clase contiene mtodos que actan sobre items del cdigo generado, del mismo modo que la clase
 * Arrays de la API de Java contiene mtodos que actan sobre arrays, y por el mismo
 * motivo: al ser arrays, no tienen una clase asociada donde se puedan poner estos
 * mtodos.
 * 
 * @author carlos
 */
public class Items
{
	
	/**
	 * Proporciona una representacin legible de un item en forma de cadena.
	 * @param item El tem que se quiere representar.
	 * @return Representacin legible del tem.
	 */
	public static String toString ( Object[] item )
	{
		StringBuffer sb = new StringBuffer("");
		sb.append("[");
		if ( item.length > 0 )
		{
			if ( item[0] instanceof Object[] )
				sb.append(Items.toString((Object[])item[0]));
			else if ( item[0] != null )
				sb.append(item[0].toString());
			else
				sb.append("null");
		}
		for ( int i = 1 ; i < item.length ; i++ )
		{
			sb.append(",");
			//sb.append(item[i].toString());
			if ( item[i] instanceof Object[] )
				sb.append(Items.toString((Object[])item[i]));
			else if ( item[i] != null )
				sb.append(item[i].toString());
			else
				sb.append("null");
		}
		sb.append("]");
		return new String(sb);
	}
	
}