/*
 * Created on 14-jul-2004
 *
 */
package schema.step;

import java.util.List;


/**
 * @author carlos
 *
 * Interfaz que deben cumplir los pasos deductivos del cdigo generado.
 */
public interface DeductiveStep {
	/**
	 * ste es el mtodo que ejecuta el paso deductivo para un item dado.
	 */
	public abstract List applyTo(Object[] item);
	 
	 /**
	  * Este mtodo nos dice si el antecedente del paso deductivo es vaco.
	  * La utilidad de esto est en que los pasos con antecedentes vacos
	  * slo se tendrn que ejecutar una vez.
	  */
	 public boolean hasEmptyAntecedent();

	 /**
	  * Este mtodo nos da los esqueletos (definiciones de conjuntos de items)
	  * que nos dan los items que pueden activar el paso.
	  */
	 public List getAssociatedSpecifications();
}