package agenda;

import element.IntElement;
import element.StringPosition;

/**
 * Priority queue agenda implementation where the priority of items
 * is determined by the last element of the item, when that element
 * is an integer element (and not a string position), or zero when it is not.
 * @author carlos
 *
 * Created at regulus, 11-nov-2006 13:25:19
 */
public class LastElementPriorityQueueAgenda extends PriorityQueueAgenda
{
	
	/**
	 * Obtains the priority of an item.
	 * @param item
	 * @return The integer value of the first element of the item,
	 * if it is a nonnegative integer (and not a StringPosition),
	 * or zero if the first element does not represent an integer
	 * number, or if it represents a negative number.
	 */
	protected int getPriority ( Object item )
	{
		Object[] theItem = (Object[]) item;
		Object lastElement = theItem[theItem.length-1];
		if ( lastElement instanceof IntElement && !( lastElement instanceof StringPosition ) )
		{
			int val = ( (IntElement)lastElement ).getValue();
			if ( val >= 0 ) return val;
			else return 0;
		}
		return 0;
	}
	
}