package element;

/**
 * Representa un elemento atmico de un esquema de anlisis sintctico.
 * 
 * @author carlos
 */
public abstract class SimpleElement implements Element 
{

	/**
	 * Soporte del patrn Visitante, hace que el visitante llame al mtodo
	 * especfico para tratar con elementos simples.
	 */
	public void accept(ElementVisitor v) 
	{
		v.visitSimpleElement ( this );
	}
	
	/**
	 * @return Una lista formada por este elemento.
	 */
	public java.util.List getLeafElements()
	{
	    java.util.List l = new java.util.ArrayList();
	    l.add(this);
	    return l;
	}
	
	/**
	 * <p>Los elementos que puedan aparecer en expresiones debern dar una implementacin
	 * para este mtodo, que slo tiene validez para elementos instanciados (en el caso
	 * de elementos no ground, se puede hacer que devuelva null o cualquier otra cosa).</p>
	 * @return Cdigo Java que nos proporciona este elemento, suponiendo que sea
	 * ground.
	 */
	public String getExpressionCode()
	{
	    System.err.println("[ERROR] Este elemento no puede formar parte de una expresin: no se ha definido el mtodo getExpressionCode()");
	    System.err.println("[ERROR] El elemento es: " + this + " (clase " + getClass() + ", instanciado = " + isGround() + ")");
	    return null;
	}

}
