package grammar.tag.util;

import java.util.Set;
import java.util.TreeSet;

import org.w3c.dom.Element;

import util.DOMNodeWrapper;

public class DuplicateTreeRenamer extends AbstractGrammarTransformer
{

	
	public String toString()
	{
		return "Renaming duplicate trees";
	}
	
	
	
	public DuplicateTreeRenamer(String inFile, String outFile, AbstractGrammarTransformer next) 
	{
		super(inFile, outFile, next);
	}

	public DuplicateTreeRenamer(String inFile, String outFile) 
	{
		super(inFile, outFile);
	}

	public DuplicateTreeRenamer(AbstractGrammarTransformer next) 
	{
		super(next);
	}
	
	private Set seenNames = new TreeSet();
	
	public void preprocessTreeNode(DOMNodeWrapper treeNode)
	{
		String name = treeNode.getAttribute("name");
		if ( seenNames.contains(name) )
		{
			name = name + "DUP1";
			((Element)treeNode.getNode()).setAttribute("name",name);
		}
		seenNames.add(name);
	}

}
