package grammar.tag.util;

import java.util.Comparator;


import util.DOMNodeListWrapper;
import util.DOMNodeWrapper;

public class HeadCornerDefaultComparator implements Comparator 
{

	public boolean isAnchor ( DOMNodeWrapper node )
	{
		return node.getAttribute("type").equals("anchor");
	}
	
	public boolean leadsToAnchor ( DOMNodeWrapper node )
	{
		if ( isAnchor(node) ) return true;
		DOMNodeListWrapper list = node.getDirectChildrenElementsByTagName("node");
		for ( int i = 0 ; i < list.size() ; i++ )
		{
			DOMNodeWrapper child = list.get(i);
			if ( leadsToAnchor(child) ) return true;
		}
		return false;
	}
	
	public boolean hasCategory ( DOMNodeWrapper node , String category )
	{
		System.out.println("Cats: " + ((org.w3c.dom.Element)node.getNode()).getAttribute("cat"));
		System.out.println("Dogs: " + node.getNode().getNodeValue());
		System.out.println("Dog: " + node.getAttribute("cat"));
		System.out.println("Pig: " + ((org.w3c.dom.Element)node.getNode()).getTagName());
		//return node.getAttribute("cat").equals(category);
		//lex nodes (lex="by") have no cat
		return node.getAttribute("cat")!=null && node.getAttribute("cat").equals(category);
	}
	
	public boolean leadsToCategory ( DOMNodeWrapper node , String category )
	{
		if ( hasCategory(node,category) ) return true;
		DOMNodeListWrapper list = node.getDirectChildrenElementsByTagName("node");
		for ( int i = 0 ; i < list.size() ; i++ )
		{
			DOMNodeWrapper child = list.get(i);
			System.out.println("Cat: " + ((org.w3c.dom.Element)child.getNode()).getAttribute("cat"));
			//System.out.println("Parent class: " + child.getNode().getParentNode().getClass());
			//System.out.println("Parent value: " + child.getNode().getParentNode());
			if ( leadsToCategory(child,category) ) return true;
		}
		return false;
	}
	
	public int compare(Object arg0, Object arg1) 
	{
		DOMNodeWrapper node1 = (DOMNodeWrapper) arg0;
		DOMNodeWrapper node2 = (DOMNodeWrapper) arg1;
		
		if ( leadsToAnchor(node1) && !leadsToAnchor(node2) ) return 1;
		if ( leadsToAnchor(node2) && !leadsToAnchor(node1) ) return -1;
		
		if ( leadsToCategory(node1,"V") && !leadsToCategory(node2,"V") ) return 1;
		if ( leadsToCategory(node2,"V") && !leadsToCategory(node1,"V") ) return -1;
		
		if ( leadsToCategory(node1,"N") && !leadsToCategory(node2,"N") ) return 1;
		if ( leadsToCategory(node2,"N") && !leadsToCategory(node1,"N") ) return -1;
		
		return 0;
	}

}
